{++

l m a c c e s s . p a s
Copyright (c) 1997 Alexander Staubo, all rights reserved.

Translation of lmaccess.h, converted using htrans 0.3.4.

--}

unit LmAccess;

{$ALIGN ON}
{$MINENUMSIZE 4}

interface

uses
  Windows, SysUtils,
  LmCons;

{!! Compatibility types: }

type
  LPCWSTR = PWideChar;
  LPBYTE = ^Byte;
  PPointer = ^Pointer;

{++ BUILD Version: 0002    // Increment this if a change has global effects

Copyright (c) 1991-1996  Microsoft Corporation

Module Name:

    lmaccess.h

Abstract:

    This file contains structures, function prototypes, and definitions
    for the NetUser, NetUserModals, NetGroup, NetAccess, and NetLogon API.

Environment:

    User Mode - Win32

Notes:

    You must include NETCONS.H before this file, since this file depends
    on values defined in NETCONS.H.

--}

//
// User Class
//

//
// Function Prototypes - User
//

function NetUserAdd (servername : LPCWSTR; level : DWORD; buf : LPBYTE;
  parm_err : LPDWORD) : DWORD; stdcall;

function NetUserEnum (servername : LPCWSTR; level : DWORD; filter : DWORD;
  var bufptr : LPBYTE; prefmaxlen : DWORD; entriesread : LPDWORD;
  totalentries : LPDWORD; resume_handle : LPDWORD) : DWORD; stdcall;

function NetUserGetInfo (servername : LPCWSTR; username : LPCWSTR;
  level : DWORD; var bufptr : LPBYTE) : DWORD; stdcall;

function NetUserSetInfo (servername : LPCWSTR; username : LPCWSTR;
  level : DWORD; buf : LPBYTE; parm_err : LPDWORD) : DWORD; stdcall;

function NetUserDel (servername : LPCWSTR;
  username : LPCWSTR) : DWORD; stdcall;

function NetUserGetGroups (servername : LPCWSTR; username : LPCWSTR;
  level : DWORD; var bufptr : LPBYTE; prefmaxlen : DWORD;
  entriesread : LPDWORD; totalentries : LPDWORD) : DWORD; stdcall;

function NetUserSetGroups (servername : LPCWSTR; username : LPCWSTR;
  level : DWORD; buf : LPBYTE; num_entries : DWORD) : DWORD; stdcall;

function NetUserGetLocalGroups (servername : LPCWSTR; username : LPCWSTR;
  level : DWORD; flags : DWORD; var bufptr : LPBYTE; prefmaxlen : DWORD;
  entriesread : LPDWORD; totalentries : LPDWORD) : DWORD; stdcall;

function NetUserModalsGet (servername : LPCWSTR; level : DWORD;
  var bufptr : LPBYTE) : DWORD; stdcall;

function NetUserModalsSet (servername : LPCWSTR; level : DWORD; buf : LPBYTE;
  parm_err : LPDWORD) : DWORD; stdcall;

function NetUserChangePassword (domainname : LPCWSTR; username : LPCWSTR;
  oldpassword : LPCWSTR; newpassword : LPCWSTR) : DWORD; stdcall;

//
//  Data Structures - User
//

type
  USER_INFO_0 =     
    packed record
      usri0_name : LPWSTR;
    end;
    
  PUSER_INFO_0 = ^USER_INFO_0;
  LPUSER_INFO_0 = ^USER_INFO_0;
  
  USER_INFO_1 = 
    packed record
      usri1_name : LPWSTR;
      usri1_password : LPWSTR;
      usri1_password_age : DWORD;
      usri1_priv : DWORD;
      usri1_home_dir : LPWSTR;
      usri1_comment : LPWSTR;
      usri1_flags : DWORD;
      usri1_script_path : LPWSTR;
    end;
    
  PUSER_INFO_1 = ^USER_INFO_1;
  LPUSER_INFO_1 = ^USER_INFO_1;
  
  USER_INFO_2 = 
    packed record
      usri2_name : LPWSTR;
      usri2_password : LPWSTR;
      usri2_password_age : DWORD;
      usri2_priv : DWORD;
      usri2_home_dir : LPWSTR;
      usri2_comment : LPWSTR;
      usri2_flags : DWORD;
      usri2_script_path : LPWSTR;
      usri2_auth_flags : DWORD;
      usri2_full_name : LPWSTR;
      usri2_usr_comment : LPWSTR;
      usri2_parms : LPWSTR;
      usri2_workstations : LPWSTR;
      usri2_last_logon : DWORD;
      usri2_last_logoff : DWORD;
      usri2_acct_expires : DWORD;
      usri2_max_storage : DWORD;
      usri2_units_per_week : DWORD;
      usri2_logon_hours : PBYTE;
      usri2_bad_pw_count : DWORD;
      usri2_num_logons : DWORD;
      usri2_logon_server : LPWSTR;
      usri2_country_code : DWORD;
      usri2_code_page : DWORD;
    end;
    
  PUSER_INFO_2 = ^USER_INFO_2;
  LPUSER_INFO_2 = ^USER_INFO_2;
  
  USER_INFO_3 = 
    packed record
      usri3_name : LPWSTR;
      usri3_password : LPWSTR;
      usri3_password_age : DWORD;
      usri3_priv : DWORD;
      usri3_home_dir : LPWSTR;
      usri3_comment : LPWSTR;
      usri3_flags : DWORD;
      usri3_script_path : LPWSTR;
      usri3_auth_flags : DWORD;
      usri3_full_name : LPWSTR;
      usri3_usr_comment : LPWSTR;
      usri3_parms : LPWSTR;
      usri3_workstations : LPWSTR;
      usri3_last_logon : DWORD;
      usri3_last_logoff : DWORD;
      usri3_acct_expires : DWORD;
      usri3_max_storage : DWORD;
      usri3_units_per_week : DWORD;
      usri3_logon_hours : PBYTE;
      usri3_bad_pw_count : DWORD;
      usri3_num_logons : DWORD;
      usri3_logon_server : LPWSTR;
      usri3_country_code : DWORD;
      usri3_code_page : DWORD;
      usri3_user_id : DWORD;
      usri3_primary_group_id : DWORD;
      usri3_profile : LPWSTR;
      usri3_home_dir_drive : LPWSTR;
      usri3_password_expired : DWORD;
    end;
    
  PUSER_INFO_3 = ^USER_INFO_3;
  LPUSER_INFO_3 = ^USER_INFO_3;
  
  USER_INFO_10 = 
    packed record
      usri10_name : LPWSTR;
      usri10_comment : LPWSTR;
      usri10_usr_comment : LPWSTR;
      usri10_full_name : LPWSTR;
    end;
    
  PUSER_INFO_10 = ^USER_INFO_10;
  LPUSER_INFO_10 = ^USER_INFO_10;
  
  USER_INFO_11 = 
    packed record
      usri11_name : LPWSTR;
      usri11_comment : LPWSTR;
      usri11_usr_comment : LPWSTR;
      usri11_full_name : LPWSTR;
      usri11_priv : DWORD;
      usri11_auth_flags : DWORD;
      usri11_password_age : DWORD;
      usri11_home_dir : LPWSTR;
      usri11_parms : LPWSTR;
      usri11_last_logon : DWORD;
      usri11_last_logoff : DWORD;
      usri11_bad_pw_count : DWORD;
      usri11_num_logons : DWORD;
      usri11_logon_server : LPWSTR;
      usri11_country_code : DWORD;
      usri11_workstations : LPWSTR;
      usri11_max_storage : DWORD;
      usri11_units_per_week : DWORD;
      usri11_logon_hours : PBYTE;
      usri11_code_page : DWORD;
    end;
    
  PUSER_INFO_11 = ^USER_INFO_11;
  LPUSER_INFO_11 = ^USER_INFO_11;
  
  USER_INFO_20 = 
    packed record
      usri20_name : LPWSTR;
      usri20_full_name : LPWSTR;
      usri20_comment : LPWSTR;
      usri20_flags : DWORD;
      usri20_user_id : DWORD;
    end;
    
  PUSER_INFO_20 = ^USER_INFO_20;
  LPUSER_INFO_20 = ^USER_INFO_20;
  
  USER_INFO_21 = 
    packed record
      usri21_password : array[0..ENCRYPTED_PWLEN - 1] of Char;
    end;
    
  PUSER_INFO_21 = ^USER_INFO_21;
  LPUSER_INFO_21 = ^USER_INFO_21;
  
  USER_INFO_22 = 
    packed record
      usri22_name : LPWSTR;
      usri22_password : array[0..16 - 1] of Char;
      usri22_password_age : DWORD;
      usri22_priv : DWORD;
      usri22_home_dir : LPWSTR;
      usri22_comment : LPWSTR;
      usri22_flags : DWORD;
      usri22_script_path : LPWSTR;
      usri22_auth_flags : DWORD;
      usri22_full_name : LPWSTR;
      usri22_usr_comment : LPWSTR;
      usri22_parms : LPWSTR;
      usri22_workstations : LPWSTR;
      usri22_last_logon : DWORD;
      usri22_last_logoff : DWORD;
      usri22_acct_expires : DWORD;
      usri22_max_storage : DWORD;
      usri22_units_per_week : DWORD;
      usri22_logon_hours : PBYTE;
      usri22_bad_pw_count : DWORD;
      usri22_num_logons : DWORD;
      usri22_logon_server : LPWSTR;
      usri22_country_code : DWORD;
      usri22_code_page : DWORD;
    end;
    
  PUSER_INFO_22 = ^USER_INFO_22;
  LPUSER_INFO_22 = ^USER_INFO_22;
  
  USER_INFO_1003 = 
    packed record
      usri1003_password : LPWSTR;
    end;
    
  PUSER_INFO_1003 = ^USER_INFO_1003;
  LPUSER_INFO_1003 = ^USER_INFO_1003;
  
  USER_INFO_1005 =     
    packed record
      usri1005_priv : DWORD;
    end;
    
  PUSER_INFO_1005 = ^USER_INFO_1005;
  LPUSER_INFO_1005 = ^USER_INFO_1005;
  
  USER_INFO_1006 = 
    packed record
      usri1006_home_dir : LPWSTR;
    end;
    
  PUSER_INFO_1006 = ^USER_INFO_1006;
  LPUSER_INFO_1006 = ^USER_INFO_1006;
  
  USER_INFO_1007 = 
    packed record
      usri1007_comment : LPWSTR;
    end;
    
  PUSER_INFO_1007 = ^USER_INFO_1007;
  LPUSER_INFO_1007 = ^USER_INFO_1007;
  
  USER_INFO_1008 = 
    packed record
      usri1008_flags : DWORD;
    end;
    
  PUSER_INFO_1008 = ^USER_INFO_1008;
  LPUSER_INFO_1008 = ^USER_INFO_1008;
  
  USER_INFO_1009 = 
    packed record
      usri1009_script_path : LPWSTR;
    end;
    
  PUSER_INFO_1009 = ^USER_INFO_1009;
  LPUSER_INFO_1009 = ^USER_INFO_1009;
  
  USER_INFO_1010 = 
    packed record
      usri1010_auth_flags : DWORD;
    end;
    
  PUSER_INFO_1010 = ^USER_INFO_1010;
  LPUSER_INFO_1010 = ^USER_INFO_1010;
  
  USER_INFO_1011 = 
    packed record
      usri1011_full_name : LPWSTR;
    end;
    
  PUSER_INFO_1011 = ^USER_INFO_1011;
  LPUSER_INFO_1011 = ^USER_INFO_1011;
  
  USER_INFO_1012 = 
    packed record
      usri1012_usr_comment : LPWSTR;
    end;
    
  PUSER_INFO_1012 = ^USER_INFO_1012;
  LPUSER_INFO_1012 = ^USER_INFO_1012;
  
  USER_INFO_1013 = 
    packed record
      usri1013_parms : LPWSTR;
    end;
    
  PUSER_INFO_1013 = ^USER_INFO_1013;
  LPUSER_INFO_1013 = ^USER_INFO_1013;
  
  USER_INFO_1014 = 
    packed record
      usri1014_workstations : LPWSTR;
    end;
    
  PUSER_INFO_1014 = ^USER_INFO_1014;
  LPUSER_INFO_1014 = ^USER_INFO_1014;
  
  USER_INFO_1017 = 
    packed record
      usri1017_acct_expires : DWORD;
    end;
    
  PUSER_INFO_1017 = ^USER_INFO_1017;
  LPUSER_INFO_1017 = ^USER_INFO_1017;
  
  USER_INFO_1018 = 
    packed record
      usri1018_max_storage : DWORD;
    end;
    
  PUSER_INFO_1018 = ^USER_INFO_1018;
  LPUSER_INFO_1018 = ^USER_INFO_1018;
  
  USER_INFO_1020 = 
    packed record
      usri1020_units_per_week : DWORD;
      usri1020_logon_hours : LPBYTE;
    end;
    
  PUSER_INFO_1020 = ^USER_INFO_1020;
  LPUSER_INFO_1020 = ^USER_INFO_1020;
  
  USER_INFO_1023 = 
    packed record
      usri1023_logon_server : LPWSTR;
    end;
    
  PUSER_INFO_1023 = ^USER_INFO_1023;
  LPUSER_INFO_1023 = ^USER_INFO_1023;
  
  USER_INFO_1024 = 
    packed record
      usri1024_country_code : DWORD;
    end;
    
  PUSER_INFO_1024 = ^USER_INFO_1024;
  LPUSER_INFO_1024 = ^USER_INFO_1024;
  
  USER_INFO_1025 = 
    packed record
      usri1025_code_page : DWORD;
    end;
    
  PUSER_INFO_1025 = ^USER_INFO_1025;
  LPUSER_INFO_1025 = ^USER_INFO_1025;
  
  USER_INFO_1051 = 
    packed record
      usri1051_primary_group_id : DWORD;
    end;
    
  PUSER_INFO_1051 = ^USER_INFO_1051;
  LPUSER_INFO_1051 = ^USER_INFO_1051;
  
  USER_INFO_1052 = 
    packed record
      usri1052_profile : LPWSTR;
    end;
    
  PUSER_INFO_1052 = ^USER_INFO_1052;
  LPUSER_INFO_1052 = ^USER_INFO_1052;
  
  USER_INFO_1053 = 
    packed record
      usri1053_home_dir_drive : LPWSTR;
    end;
    
  PUSER_INFO_1053 = ^USER_INFO_1053;
  LPUSER_INFO_1053 = ^USER_INFO_1053;
  
//
//  Data Structures - User Modals
//

  USER_MODALS_INFO_0 = 
    packed record
      usrmod0_min_passwd_len : DWORD;
      usrmod0_max_passwd_age : DWORD;
      usrmod0_min_passwd_age : DWORD;
      usrmod0_force_logoff : DWORD;
      usrmod0_password_hist_len : DWORD;
    end;
    
  PUSER_MODALS_INFO_0 = ^USER_MODALS_INFO_0;
  LPUSER_MODALS_INFO_0 = ^USER_MODALS_INFO_0;
  
  USER_MODALS_INFO_1 = 
    packed record
      usrmod1_role : DWORD;
      usrmod1_primary : LPWSTR;
    end;
    
  PUSER_MODALS_INFO_1 = ^USER_MODALS_INFO_1;
  LPUSER_MODALS_INFO_1 = ^USER_MODALS_INFO_1;
  
  USER_MODALS_INFO_2 = 
    packed record
      usrmod2_domain_name : LPWSTR;
      usrmod2_domain_id : PSID;
    end;
    
  PUSER_MODALS_INFO_2 = ^USER_MODALS_INFO_2;
  LPUSER_MODALS_INFO_2 = ^USER_MODALS_INFO_2;
  
  USER_MODALS_INFO_3 = 
    packed record
      usrmod3_lockout_duration : DWORD;
      usrmod3_lockout_observation_window : DWORD;
      usrmod3_lockout_threshold : DWORD;
    end;
    
  PUSER_MODALS_INFO_3 = ^USER_MODALS_INFO_3;
  LPUSER_MODALS_INFO_3 = ^USER_MODALS_INFO_3;
  
  USER_MODALS_INFO_1001 = 
    packed record
      usrmod1001_min_passwd_len : DWORD;
    end;
    
  PUSER_MODALS_INFO_1001 = ^USER_MODALS_INFO_1001;
  LPUSER_MODALS_INFO_1001 = ^USER_MODALS_INFO_1001;
  
  USER_MODALS_INFO_1002 = 
    packed record
      usrmod1002_max_passwd_age : DWORD;
    end;
    
  PUSER_MODALS_INFO_1002 = ^USER_MODALS_INFO_1002;
  LPUSER_MODALS_INFO_1002 = ^USER_MODALS_INFO_1002;
  
  USER_MODALS_INFO_1003 = 
    packed record
      usrmod1003_min_passwd_age : DWORD;
    end;
    
  PUSER_MODALS_INFO_1003 = ^USER_MODALS_INFO_1003;
  LPUSER_MODALS_INFO_1003 = ^USER_MODALS_INFO_1003;
  
  USER_MODALS_INFO_1004 = 
    packed record
      usrmod1004_force_logoff : DWORD;
    end;
    
  PUSER_MODALS_INFO_1004 = ^USER_MODALS_INFO_1004;
  LPUSER_MODALS_INFO_1004 = ^USER_MODALS_INFO_1004;
  
  USER_MODALS_INFO_1005 = 
    packed record
      usrmod1005_password_hist_len : DWORD;
    end;
    
  PUSER_MODALS_INFO_1005 = ^USER_MODALS_INFO_1005;
  LPUSER_MODALS_INFO_1005 = ^USER_MODALS_INFO_1005;
  
  USER_MODALS_INFO_1006 = 
    packed record
      usrmod1006_role : DWORD;
    end;
    
  PUSER_MODALS_INFO_1006 = ^USER_MODALS_INFO_1006;
  LPUSER_MODALS_INFO_1006 = ^USER_MODALS_INFO_1006;
  
  USER_MODALS_INFO_1007 = 
    packed record
      usrmod1007_primary : LPWSTR;
    end;
    
  PUSER_MODALS_INFO_1007 = ^USER_MODALS_INFO_1007;
  LPUSER_MODALS_INFO_1007 = ^USER_MODALS_INFO_1007;
  
//
// Special Values and Constants - User
//

//
//  Bit masks for field usriX_flags of USER_INFO_X (X = 0/1).
//

const
  UF_SCRIPT = $0001;
  UF_ACCOUNTDISABLE = $0002;
  UF_HOMEDIR_REQUIRED = $0008;
  UF_LOCKOUT = $0010;
  UF_PASSWD_NOTREQD = $0020;
  UF_PASSWD_CANT_CHANGE = $0040;

//
// Account type bits as part of usri_flags.
//

  UF_TEMP_DUPLICATE_ACCOUNT = $0100;
  UF_NORMAL_ACCOUNT = $0200;
  UF_INTERDOMAIN_TRUST_ACCOUNT = $0800;
  UF_WORKSTATION_TRUST_ACCOUNT = $1000;
  UF_SERVER_TRUST_ACCOUNT = $2000;
  UF_MACHINE_ACCOUNT_MASK = (UF_INTERDOMAIN_TRUST_ACCOUNT or UF_WORKSTATION_TRUST_ACCOUNT or UF_SERVER_TRUST_ACCOUNT);
  UF_ACCOUNT_TYPE_MASK = (UF_TEMP_DUPLICATE_ACCOUNT or UF_NORMAL_ACCOUNT or UF_INTERDOMAIN_TRUST_ACCOUNT or UF_WORKSTATION_TRUST_ACCOUNT or UF_SERVER_TRUST_ACCOUNT);
  UF_DONT_EXPIRE_PASSWD = $10000;
  UF_MNS_LOGON_ACCOUNT = $20000;
  UF_SETTABLE_BITS = (UF_SCRIPT or UF_ACCOUNTDISABLE or UF_LOCKOUT or UF_HOMEDIR_REQUIRED or UF_PASSWD_NOTREQD or UF_PASSWD_CANT_CHANGE or UF_ACCOUNT_TYPE_MASK or UF_DONT_EXPIRE_PASSWD or UF_MNS_LOGON_ACCOUNT);

//
// bit masks for the NetUserEnum filter parameter.
//

  FILTER_TEMP_DUPLICATE_ACCOUNT = ($0001);
  FILTER_NORMAL_ACCOUNT = ($0002);
// #define FILTER_PROXY_ACCOUNT                (0x0004)
  FILTER_INTERDOMAIN_TRUST_ACCOUNT = ($0008);
  FILTER_WORKSTATION_TRUST_ACCOUNT = ($0010);
  FILTER_SERVER_TRUST_ACCOUNT = ($0020);

//
// bit masks for the NetUserGetLocalGroups flags
//

  LG_INCLUDE_INDIRECT = ($0001);

//
//  Bit masks for field usri2_auth_flags of USER_INFO_2.
//

  AF_OP_PRINT = $1;
  AF_OP_COMM = $2;
  AF_OP_SERVER = $4;
  AF_OP_ACCOUNTS = $8;
  AF_SETTABLE_BITS = (AF_OP_PRINT or AF_OP_COMM or AF_OP_SERVER or AF_OP_ACCOUNTS);

//
//  UAS role manifests under NETLOGON
//

  UAS_ROLE_STANDALONE = 0;
  UAS_ROLE_MEMBER = 1;
  UAS_ROLE_BACKUP = 2;
  UAS_ROLE_PRIMARY = 3;

//
//  Values for ParmError for NetUserSetInfo.
//

  USER_NAME_PARMNUM = 1;
  USER_PASSWORD_PARMNUM = 3;
  USER_PASSWORD_AGE_PARMNUM = 4;
  USER_PRIV_PARMNUM = 5;
  USER_HOME_DIR_PARMNUM = 6;
  USER_COMMENT_PARMNUM = 7;
  USER_FLAGS_PARMNUM = 8;
  USER_SCRIPT_PATH_PARMNUM = 9;
  USER_AUTH_FLAGS_PARMNUM = 10;
  USER_FULL_NAME_PARMNUM = 11;
  USER_USR_COMMENT_PARMNUM = 12;
  USER_PARMS_PARMNUM = 13;
  USER_WORKSTATIONS_PARMNUM = 14;
  USER_LAST_LOGON_PARMNUM = 15;
  USER_LAST_LOGOFF_PARMNUM = 16;
  USER_ACCT_EXPIRES_PARMNUM = 17;
  USER_MAX_STORAGE_PARMNUM = 18;
  USER_UNITS_PER_WEEK_PARMNUM = 19;
  USER_LOGON_HOURS_PARMNUM = 20;
  USER_PAD_PW_COUNT_PARMNUM = 21;
  USER_NUM_LOGONS_PARMNUM = 22;
  USER_LOGON_SERVER_PARMNUM = 23;
  USER_COUNTRY_CODE_PARMNUM = 24;
  USER_CODE_PAGE_PARMNUM = 25;
  USER_PRIMARY_GROUP_PARMNUM = 51;
  USER_PROFILE = 52;
  USER_PROFILE_PARMNUM = 52;
  USER_HOME_DIR_DRIVE_PARMNUM = 53;

//
// the new infolevel counterparts of the old info level + parmnum
//

  USER_NAME_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_NAME_PARMNUM);
  USER_PASSWORD_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_PASSWORD_PARMNUM);
  USER_PASSWORD_AGE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_PASSWORD_AGE_PARMNUM);
  USER_PRIV_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_PRIV_PARMNUM);
  USER_HOME_DIR_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_HOME_DIR_PARMNUM);
  USER_COMMENT_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_COMMENT_PARMNUM);
  USER_FLAGS_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_FLAGS_PARMNUM);
  USER_SCRIPT_PATH_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_SCRIPT_PATH_PARMNUM);
  USER_AUTH_FLAGS_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_AUTH_FLAGS_PARMNUM);
  USER_FULL_NAME_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_FULL_NAME_PARMNUM);
  USER_USR_COMMENT_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_USR_COMMENT_PARMNUM);
  USER_PARMS_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_PARMS_PARMNUM);
  USER_WORKSTATIONS_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_WORKSTATIONS_PARMNUM);
  USER_LAST_LOGON_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_LAST_LOGON_PARMNUM);
  USER_LAST_LOGOFF_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_LAST_LOGOFF_PARMNUM);
  USER_ACCT_EXPIRES_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_ACCT_EXPIRES_PARMNUM);
  USER_MAX_STORAGE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_MAX_STORAGE_PARMNUM);
  USER_UNITS_PER_WEEK_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_UNITS_PER_WEEK_PARMNUM);
  USER_LOGON_HOURS_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_LOGON_HOURS_PARMNUM);
  USER_PAD_PW_COUNT_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_PAD_PW_COUNT_PARMNUM);
  USER_NUM_LOGONS_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_NUM_LOGONS_PARMNUM);
  USER_LOGON_SERVER_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_LOGON_SERVER_PARMNUM);
  USER_COUNTRY_CODE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_COUNTRY_CODE_PARMNUM);
  USER_CODE_PAGE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_CODE_PAGE_PARMNUM);
  USER_PRIMARY_GROUP_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_PRIMARY_GROUP_PARMNUM);
{!! Removed because USER_POSIX_ID_PARMNUM doesn't seem to be defined anywhere
  USER_POSIX_ID_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + USER_POSIX_ID_PARMNUM);
}
  USER_HOME_DIR_DRIVE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    USER_HOME_DIR_DRIVE_PARMNUM);

//
//  For SetInfo call (parmnum 0) when password change not required
//

  NULL_USERSETINFO_PASSWD = '              ';
  TIMEQ_FOREVER = (Integer(-1));
  USER_MAXSTORAGE_UNLIMITED = (Integer(-1));
  USER_NO_LOGOFF = (Integer(-1));
  UNITS_PER_DAY = 24;
  UNITS_PER_WEEK = UNITS_PER_DAY * 7;

//
// Privilege levels (USER_INFO_X field usriX_priv (X = 0/1)).
//

  USER_PRIV_MASK = $3;
  USER_PRIV_GUEST = 0;
  USER_PRIV_USER = 1;
  USER_PRIV_ADMIN = 2;

//
// user modals related defaults
//

  MAX_PASSWD_LEN = PWLEN;
  DEF_MIN_PWLEN = 6;
  DEF_PWUNIQUENESS = 5;
  DEF_MAX_PWHIST = 8;
  DEF_MAX_PWAGE = TIMEQ_FOREVER;
  DEF_MIN_PWAGE = Integer(0);
  DEF_FORCE_LOGOFF = Integer($ffffffff);
  DEF_MAX_BADPW = 0;
  ONE_DAY = Integer(1 * 24 * 3600);

//
// User Logon Validation (codes returned)
//

  VALIDATED_LOGON = 0;
  PASSWORD_EXPIRED = 2;
  NON_VALIDATED_LOGON = 3;
  VALID_LOGOFF = 1;

//
// parmnum manifests for user modals
//

  MODALS_MIN_PASSWD_LEN_PARMNUM = 1;
  MODALS_MAX_PASSWD_AGE_PARMNUM = 2;
  MODALS_MIN_PASSWD_AGE_PARMNUM = 3;
  MODALS_FORCE_LOGOFF_PARMNUM = 4;
  MODALS_PASSWD_HIST_LEN_PARMNUM = 5;
  MODALS_ROLE_PARMNUM = 6;
  MODALS_PRIMARY_PARMNUM = 7;
  MODALS_DOMAIN_NAME_PARMNUM = 8;
  MODALS_DOMAIN_ID_PARMNUM = 9;
  MODALS_LOCKOUT_DURATION_PARMNUM = 10;
  MODALS_LOCKOUT_OBSERVATION_WINDOW_PARMNUM = 11;
  MODALS_LOCKOUT_THRESHOLD_PARMNUM = 12;

//
// the new infolevel counterparts of the old info level + parmnum
//

  MODALS_MIN_PASSWD_LEN_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_MIN_PASSWD_LEN_PARMNUM);
  MODALS_MAX_PASSWD_AGE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_MAX_PASSWD_AGE_PARMNUM);
  MODALS_MIN_PASSWD_AGE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_MIN_PASSWD_AGE_PARMNUM);
  MODALS_FORCE_LOGOFF_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_FORCE_LOGOFF_PARMNUM);
  MODALS_PASSWD_HIST_LEN_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_PASSWD_HIST_LEN_PARMNUM);
  MODALS_ROLE_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + MODALS_ROLE_PARMNUM);
  MODALS_PRIMARY_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + MODALS_PRIMARY_PARMNUM);
  MODALS_DOMAIN_NAME_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_DOMAIN_NAME_PARMNUM);
  MODALS_DOMAIN_ID_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    MODALS_DOMAIN_ID_PARMNUM);
  
//
// Group Class
//
  
//
// Function Prototypes
//

function NetGroupAdd (servername : LPCWSTR; level : DWORD; buf : LPBYTE;
  parm_err : LPDWORD) : DWORD; stdcall;

function NetGroupAddUser (servername : LPCWSTR; GroupName : LPCWSTR;
  username : LPCWSTR) : DWORD; stdcall;

function NetGroupEnum (servername : LPCWSTR; level : DWORD;
  var bufptr : LPBYTE; prefmaxlen : DWORD; entriesread : LPDWORD;
  totalentries : LPDWORD; resume_handle : LPDWORD) : DWORD; stdcall;

function NetGroupGetInfo (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; var bufptr : LPBYTE) : DWORD; stdcall;

function NetGroupSetInfo (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; buf : LPBYTE; parm_err : LPDWORD) : DWORD; stdcall;

function NetGroupDel (servername : LPCWSTR;
  groupname : LPCWSTR) : DWORD; stdcall;

function NetGroupDelUser (servername : LPCWSTR; GroupName : LPCWSTR;
  Username : LPCWSTR) : DWORD; stdcall;

function NetGroupGetUsers (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; var bufptr : LPBYTE; prefmaxlen : DWORD;
  entriesread : LPDWORD; totalentries : LPDWORD;
  ResumeHandle : LPDWORD) : DWORD; stdcall;

function NetGroupSetUsers (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; buf : LPBYTE; totalentries : DWORD) : DWORD; stdcall;

//
//  Data Structures - Group
//

type
  GROUP_INFO_0 =     
    packed record
      grpi0_name : LPWSTR;
    end;
    
  PGROUP_INFO_0 = ^GROUP_INFO_0;
  LPGROUP_INFO_0 = ^GROUP_INFO_0;
  
  GROUP_INFO_1 = 
    packed record
      grpi1_name : LPWSTR;
      grpi1_comment : LPWSTR;
    end;
    
  PGROUP_INFO_1 = ^GROUP_INFO_1;
  LPGROUP_INFO_1 = ^GROUP_INFO_1;
  
  GROUP_INFO_2 = 
    packed record
      grpi2_name : LPWSTR;
      grpi2_comment : LPWSTR;
      grpi2_group_id : DWORD;
      grpi2_attributes : DWORD;
    end;
    
  PGROUP_INFO_2 = ^GROUP_INFO_2;
  
  GROUP_INFO_1002 = 
    packed record
      grpi1002_comment : LPWSTR;
    end;
    
  PGROUP_INFO_1002 = ^GROUP_INFO_1002;
  LPGROUP_INFO_1002 = ^GROUP_INFO_1002;
  
  GROUP_INFO_1005 = 
    packed record
      grpi1005_attributes : DWORD;
    end;
    
  PGROUP_INFO_1005 = ^GROUP_INFO_1005;
  LPGROUP_INFO_1005 = ^GROUP_INFO_1005;
  
  GROUP_USERS_INFO_0 = 
    packed record
      grui0_name : LPWSTR;
    end;
    
  PGROUP_USERS_INFO_0 = ^GROUP_USERS_INFO_0;
  LPGROUP_USERS_INFO_0 = ^GROUP_USERS_INFO_0;
  
  GROUP_USERS_INFO_1 = 
    packed record
      grui1_name : LPWSTR;
      grui1_attributes : DWORD;
    end;
    
  PGROUP_USERS_INFO_1 = ^GROUP_USERS_INFO_1;
  LPGROUP_USERS_INFO_1 = ^GROUP_USERS_INFO_1;
  
//
// Special Values and Constants - Group
//

const
  GROUPIDMASK = $8000;        // MSB is set if uid refers
                              // to a group

//
// Predefined group for all normal users, administrators and guests
// LOCAL is a special group for pinball local security.
//

  GROUP_SPECIALGRP_USERS = 'USERS';
  GROUP_SPECIALGRP_ADMINS = 'ADMINS';
  GROUP_SPECIALGRP_GUESTS = 'GUESTS';
  GROUP_SPECIALGRP_LOCAL = 'LOCAL';

//
// parmnum manifests for SetInfo calls (only comment is settable)
//

  GROUP_ALL_PARMNUM = 0;
  GROUP_NAME_PARMNUM = 1;
  GROUP_COMMENT_PARMNUM = 2;
  GROUP_ATTRIBUTES_PARMNUM = 3;

//
// the new infolevel counterparts of the old info level + parmnum
//

  GROUP_ALL_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + GROUP_ALL_PARMNUM);
  GROUP_NAME_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + GROUP_NAME_PARMNUM);
  GROUP_COMMENT_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL + GROUP_COMMENT_PARMNUM);
  GROUP_ATTRIBUTES_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    GROUP_ATTRIBUTES_PARMNUM);
{!! Remvoed because GROUP_POSIX_ID_PARMNUM doesn't seem to be defined anywhere
  GROUP_POSIX_ID_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    GROUP_POSIX_ID_PARMNUM);
}
  
//
// LocalGroup Class
//
  
//
// Function Prototypes
//

function NetLocalGroupAdd (servername : LPCWSTR; level : DWORD; buf : LPBYTE;
  parm_err : LPDWORD) : DWORD; stdcall;

function NetLocalGroupAddMember (servername : LPCWSTR; groupname : LPCWSTR;
  membersid : PSID) : DWORD; stdcall;

function NetLocalGroupEnum (servername : LPCWSTR; level : DWORD;
  var bufptr : LPBYTE; prefmaxlen : DWORD; entriesread : LPDWORD;
  totalentries : LPDWORD; resumehandle : LPDWORD) : DWORD; stdcall;

function NetLocalGroupGetInfo (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; var bufptr : LPBYTE) : DWORD; stdcall;

function NetLocalGroupSetInfo (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; buf : LPBYTE; parm_err : LPDWORD) : DWORD; stdcall;

function NetLocalGroupDel (servername : LPCWSTR;
  groupname : LPCWSTR) : DWORD; stdcall;

function NetLocalGroupDelMember (servername : LPCWSTR; groupname : LPCWSTR;
  membersid : PSID) : DWORD; stdcall;

function NetLocalGroupGetMembers (servername : LPCWSTR;
  localgroupname : LPCWSTR; level : DWORD; var bufptr : LPBYTE;
  prefmaxlen : DWORD; entriesread : LPDWORD; totalentries : LPDWORD;
  resumehandle : LPDWORD) : DWORD; stdcall;

function NetLocalGroupSetMembers (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; buf : LPBYTE; totalentries : DWORD) : DWORD; stdcall;

function NetLocalGroupAddMembers (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; buf : LPBYTE; totalentries : DWORD) : DWORD; stdcall;

function NetLocalGroupDelMembers (servername : LPCWSTR; groupname : LPCWSTR;
  level : DWORD; buf : LPBYTE; totalentries : DWORD) : DWORD; stdcall;

//
//  Data Structures - LocalGroup
//

type
  LOCALGROUP_INFO_0 = 
    packed record
      lgrpi0_name : LPWSTR;
    end;
    
  PLOCALGROUP_INFO_0 = ^LOCALGROUP_INFO_0;
  LPLOCALGROUP_INFO_0 = ^LOCALGROUP_INFO_0;
  
  LOCALGROUP_INFO_1 = 
    packed record
      lgrpi1_name : LPWSTR;
      lgrpi1_comment : LPWSTR;
    end;
    
  PLOCALGROUP_INFO_1 = ^LOCALGROUP_INFO_1;
  LPLOCALGROUP_INFO_1 = ^LOCALGROUP_INFO_1;
  
  LOCALGROUP_INFO_1002 = 
    packed record
      lgrpi1002_comment : LPWSTR;
    end;
    
  PLOCALGROUP_INFO_1002 = ^LOCALGROUP_INFO_1002;
  LPLOCALGROUP_INFO_1002 = ^LOCALGROUP_INFO_1002;
  
  LOCALGROUP_MEMBERS_INFO_0 = 
    packed record
      lgrmi0_sid : PSID;
    end;
    
  PLOCALGROUP_MEMBERS_INFO_0 = ^LOCALGROUP_MEMBERS_INFO_0;
  LPLOCALGROUP_MEMBERS_INFO_0 = ^LOCALGROUP_MEMBERS_INFO_0;
  
  LOCALGROUP_MEMBERS_INFO_1 = 
    packed record
      lgrmi1_sid : PSID;
      lgrmi1_sidusage : SID_NAME_USE;
      lgrmi1_name : LPWSTR;
    end;
    
  PLOCALGROUP_MEMBERS_INFO_1 = ^LOCALGROUP_MEMBERS_INFO_1;
  LPLOCALGROUP_MEMBERS_INFO_1 = ^LOCALGROUP_MEMBERS_INFO_1;
  
  LOCALGROUP_MEMBERS_INFO_2 = 
    packed record
      lgrmi2_sid : PSID;
      lgrmi2_sidusage : SID_NAME_USE;
      lgrmi2_domainandname : LPWSTR;
    end;
    
  PLOCALGROUP_MEMBERS_INFO_2 = ^LOCALGROUP_MEMBERS_INFO_2;
  LPLOCALGROUP_MEMBERS_INFO_2 = ^LOCALGROUP_MEMBERS_INFO_2;
  
  LOCALGROUP_MEMBERS_INFO_3 = 
    packed record
      lgrmi3_domainandname : LPWSTR;
    end;
    
  PLOCALGROUP_MEMBERS_INFO_3 = ^LOCALGROUP_MEMBERS_INFO_3;
  LPLOCALGROUP_MEMBERS_INFO_3 = ^LOCALGROUP_MEMBERS_INFO_3;
  
  LOCALGROUP_USERS_INFO_0 = 
    packed record
      lgrui0_name : LPWSTR;
    end;
    
  PLOCALGROUP_USERS_INFO_0 = ^LOCALGROUP_USERS_INFO_0;
  LPLOCALGROUP_USERS_INFO_0 = ^LOCALGROUP_USERS_INFO_0;
  
const
  LOCALGROUP_NAME_PARMNUM = 1;
  LOCALGROUP_COMMENT_PARMNUM = 2;

//
// Display Information APIs
//

function NetQueryDisplayInformation (ServerName : LPCWSTR; Level : DWORD;
  Index : DWORD; EntriesRequested : DWORD; PreferredMaximumLength : DWORD;
  ReturnedEntryCount : LPDWORD; SortedBuffer : PPointer) : DWORD; stdcall;

function NetGetDisplayInformationIndex (ServerName : LPCWSTR; Level : DWORD;
  Prefix : LPCWSTR; Index : LPDWORD) : DWORD; stdcall;

//
// QueryDisplayInformation levels

type
  NET_DISPLAY_USER = 
    packed record
      usri1_name : LPWSTR;
      usri1_comment : LPWSTR;
      usri1_flags : DWORD;
      usri1_full_name : LPWSTR;
      usri1_user_id : DWORD;
      usri1_next_index : DWORD;
    end;
    
  PNET_DISPLAY_USER = ^NET_DISPLAY_USER;
  
  NET_DISPLAY_MACHINE = 
    packed record
      usri2_name : LPWSTR;
      usri2_comment : LPWSTR;
      usri2_flags : DWORD;
      usri2_user_id : DWORD;
      usri2_next_index : DWORD;
    end;
    
  PNET_DISPLAY_MACHINE = ^NET_DISPLAY_MACHINE;
  
  NET_DISPLAY_GROUP = 
    packed record
      grpi3_name : LPWSTR;
      grpi3_comment : LPWSTR;
      grpi3_group_id : DWORD;
      grpi3_attributes : DWORD;
      grpi3_next_index : DWORD;
    end;
    
  PNET_DISPLAY_GROUP = ^NET_DISPLAY_GROUP;
  
//
// Access Class
//
  
//
// Function Prototypes - Access
//
//
// The NetAccess APIs are only available to downlevel
//

{!! API function aliases have been removed. Use the Rx* functions. Ie., if
  you need to use the function called NetAccessAdd, use RxNetAccessAdd. }

function RxNetAccessAdd (servername : LPCWSTR; level : DWORD; buf : LPBYTE;
  parm_err : LPDWORD) : DWORD; stdcall;

function RxNetAccessEnum (servername : LPCWSTR; BasePath : LPCWSTR;
  Recursive : DWORD; level : DWORD; var bufptr : LPBYTE; prefmaxlen : DWORD;
  entriesread : LPDWORD; totalentries : LPDWORD;
  resume_handle : LPDWORD) : DWORD; stdcall;

function RxNetAccessGetInfo (servername : LPCWSTR; resource : LPCWSTR;
  level : DWORD; var bufptr : LPBYTE) : DWORD; stdcall;

function RxNetAccessSetInfo (servername : LPCWSTR; resource : LPCWSTR;
  level : DWORD; buf : LPBYTE; parm_err : LPDWORD) : DWORD; stdcall;

function RxNetAccessDel (servername : LPCWSTR;
  resource : LPCWSTR) : DWORD; stdcall;

function RxNetAccessGetUserPerms (servername : LPCWSTR; UGname : LPCWSTR;
  resource : LPCWSTR; Perms : LPDWORD) : DWORD; stdcall;

//
// Data Structures - Access
//

type
  ACCESS_INFO_0 = 
    packed record
      acc0_resource_name : LPWSTR;
    end;
    
  PACCESS_INFO_0 = ^ACCESS_INFO_0;
  LPACCESS_INFO_0 = ^ACCESS_INFO_0;
  
  ACCESS_INFO_1 = 
    packed record
      acc1_resource_name : LPWSTR;
      acc1_attr : DWORD;
      acc1_count : DWORD;
    end;
    
  PACCESS_INFO_1 = ^ACCESS_INFO_1;
  LPACCESS_INFO_1 = ^ACCESS_INFO_1;
  
  ACCESS_INFO_1002 = 
    packed record
      acc1002_attr : DWORD;
    end;
    
  PACCESS_INFO_1002 = ^ACCESS_INFO_1002;
  LPACCESS_INFO_1002 = ^ACCESS_INFO_1002;
  
  ACCESS_LIST = 
    packed record
      acl_ugname : LPWSTR;
      acl_access : DWORD;
    end;
    
  PACCESS_LIST = ^ACCESS_LIST;
  LPACCESS_LIST = ^ACCESS_LIST;
  
//
// Special Values and Constants - Access
//

//
// Maximum number of permission entries for each resource.
//

const
  MAXPERMENTRIES = 64;

//
//  Bit values for the access permissions.  ACCESS_ALL is a handy
//  way to specify maximum permissions.  These are used in
//  acl_access field of access_list structures.
//

  ACCESS_NONE = 0;
  ACCESS_READ = $01;
  ACCESS_WRITE = $02;
  ACCESS_CREATE = $04;
  ACCESS_EXEC = $08;
  ACCESS_DELETE = $10;
  ACCESS_ATRIB = $20;
  ACCESS_PERM = $40;
  ACCESS_GROUP = $8000;
  ACCESS_ALL = (ACCESS_READ or ACCESS_WRITE or ACCESS_CREATE or
    ACCESS_EXEC or ACCESS_DELETE or ACCESS_ATRIB or ACCESS_PERM);

//
// Bit values for the acc1_attr field of the ACCESS_INFO_1 structure.
//

  ACCESS_AUDIT = $1;
  ACCESS_SUCCESS_OPEN = $10;
  ACCESS_SUCCESS_WRITE = $20;
  ACCESS_SUCCESS_DELETE = $40;
  ACCESS_SUCCESS_ACL = $80;
  ACCESS_SUCCESS_MASK = $F0;
  ACCESS_FAIL_OPEN = $100;
  ACCESS_FAIL_WRITE = $200;
  ACCESS_FAIL_DELETE = $400;
  ACCESS_FAIL_ACL = $800;
  ACCESS_FAIL_MASK = $F00;
  ACCESS_FAIL_SHIFT = 4;

//
// Parmnum value for NetAccessSetInfo.
//

  ACCESS_RESOURCE_NAME_PARMNUM = 1;
  ACCESS_ATTR_PARMNUM = 2;
  ACCESS_COUNT_PARMNUM = 3;
  ACCESS_ACCESS_LIST_PARMNUM = 4;

//
// the new infolevel counterparts of the old info level + parmnum
//

  ACCESS_RESOURCE_NAME_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    ACCESS_RESOURCE_NAME_PARMNUM);
  ACCESS_ATTR_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    ACCESS_ATTR_PARMNUM);
  ACCESS_COUNT_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    ACCESS_COUNT_PARMNUM);
  ACCESS_ACCESS_LIST_INFOLEVEL = (PARMNUM_BASE_INFOLEVEL +
    ACCESS_ACCESS_LIST_PARMNUM);

//
// ACCESS_LETTERS defines a letter for each bit position in
// the acl_access field of struct access_list.  Note that some
// bits have a corresponding letter of ' ' (space).
//

  ACCESS_LETTERS = 'RWCXDAP         ';
  
//
// Domain Class
//
  
//
// Function Prototypes - Domain
//

function NetGetDCName (servername : LPCWSTR; domainname : LPCWSTR;
  var bufptr : LPBYTE) : DWORD; stdcall;

function NetGetAnyDCName (servername : LPCWSTR; domainname : LPCWSTR;
  var bufptr : LPBYTE) : DWORD; stdcall;

function I_NetLogonControl (ServerName : LPCWSTR; FunctionCode : DWORD;
  QueryLevel : DWORD; var Buffer : LPBYTE) : DWORD; stdcall;

function I_NetLogonControl2 (ServerName : LPCWSTR; FunctionCode : DWORD;
  QueryLevel : DWORD; Data : LPBYTE; var Buffer : LPBYTE) : DWORD; stdcall;

type
  NTSTATUS = Longint;
  PNTSTATUS = ^NTSTATUS;
  
function NetEnumerateTrustedDomains (ServerName : LPWSTR;
  var DomainNames : LPWSTR) : NTSTATUS;

//
// Special Values and Constants - Domain
//

//
// FunctionCode values for I_NetLogonControl.
//
// NOTE : if you change the following NETLOGON_CONTROL_* values,
// change them in net\svcdlls\logonsrv\logon.idl file also.
//

const
  NETLOGON_CONTROL_QUERY = 1;
  NETLOGON_CONTROL_REPLICATE = 2;
  NETLOGON_CONTROL_SYNCHRONIZE = 3;
  NETLOGON_CONTROL_PDC_REPLICATE = 4;
  NETLOGON_CONTROL_REDISCOVER = 5;
  NETLOGON_CONTROL_TC_QUERY = 6;
  NETLOGON_CONTROL_TRANSPORT_NOTIFY = 7;
  NETLOGON_CONTROL_FIND_USER = 8;

// Debug function codes

  NETLOGON_CONTROL_UNLOAD_NETLOGON_DLL = $FFF;
  NETLOGON_CONTROL_BACKUP_CHANGE_LOG = $FFFC;
  NETLOGON_CONTROL_TRUNCATE_LOG = $FFFD;
  NETLOGON_CONTROL_SET_DBFLAG = $FFFE;
  NETLOGON_CONTROL_BREAKPOINT = $FFFF;

//
// Query level 1 for I_NetLogonControl
//
  
type
  NETLOGON_INFO_1 = 
    packed record
      netlog1_flags : DWORD;
      netlog1_pdc_connection_status : DWORD;
    end;
    
  PNETLOGON_INFO_1 = ^NETLOGON_INFO_1;
  
  NETLOGON_INFO_2 = 
    packed record
      netlog2_flags : DWORD;
      netlog2_pdc_connection_status : DWORD;
      netlog2_trusted_dc_name : LPWSTR;
      netlog2_tc_connection_status : DWORD;
    end;
    
  PNETLOGON_INFO_2 = ^NETLOGON_INFO_2;
  
  NETLOGON_INFO_3 = 
    packed record
      netlog3_flags : DWORD;
      netlog3_logon_attempts : DWORD;
      netlog3_reserved1 : DWORD;
      netlog3_reserved2 : DWORD;
      netlog3_reserved3 : DWORD;
      netlog3_reserved4 : DWORD;
      netlog3_reserved5 : DWORD;
    end;
    
  PNETLOGON_INFO_3 = ^NETLOGON_INFO_3;
  
  NETLOGON_INFO_4 = 
    packed record
      netlog4_trusted_dc_name : LPWSTR;
      netlog4_trusted_domain_name : LPWSTR;
    end;
    
  PNETLOGON_INFO_4 = ^NETLOGON_INFO_4;
  
//
// Values of netlog1_flags
//

const
  NETLOGON_REPLICATION_NEEDED = $01;
  NETLOGON_REPLICATION_IN_PROGRESS = $02;
  NETLOGON_FULL_SYNC_REPLICATION = $04;
  NETLOGON_REDO_NEEDED = $08;
  
implementation

const
  NetApiDll = 'netapi32.dll';

function NetUserAdd; external NetApiDll name 'NetUserAdd';
function NetUserEnum; external NetApiDll name 'NetUserEnum';
function NetUserGetInfo; external NetApiDll name 'NetUserGetInfo';
function NetUserSetInfo; external NetApiDll name 'NetUserSetInfo';
function NetUserDel; external NetApiDll name 'NetUserDel';
function NetUserGetGroups; external NetApiDll name 'NetUserGetGroups';
function NetUserSetGroups; external NetApiDll name 'NetUserSetGroups';
function NetUserGetLocalGroups; external NetApiDll
  name   'NetUserGetLocalGroups';
function NetUserModalsGet; external NetApiDll name 'NetUserModalsGet';
function NetUserModalsSet; external NetApiDll name 'NetUserModalsSet';
function NetUserChangePassword; external NetApiDll
  name 'NetUserChangePassword';
function NetGroupAdd; external NetApiDll name 'NetGroupAdd';
function NetGroupAddUser; external NetApiDll name 'NetGroupAddUser';
function NetGroupEnum; external NetApiDll name 'NetGroupEnum';
function NetGroupGetInfo; external NetApiDll name 'NetGroupGetInfo';
function NetGroupSetInfo; external NetApiDll name 'NetGroupSetInfo';
function NetGroupDel; external NetApiDll name 'NetGroupDel';
function NetGroupDelUser; external NetApiDll name 'NetGroupDelUser';
function NetGroupGetUsers; external NetApiDll name 'NetGroupGetUsers';
function NetGroupSetUsers; external NetApiDll name 'NetGroupSetUsers';
function NetLocalGroupAdd; external NetApiDll name 'NetLocalGroupAdd';
function NetLocalGroupAddMember; external NetApiDll
  name 'NetLocalGroupAddMember';
function NetLocalGroupEnum; external NetApiDll name 'NetLocalGroupEnum';
function NetLocalGroupGetInfo; external NetApiDll
  name 'NetLocalGroupGetInfo';
function NetLocalGroupSetInfo; external NetApiDll
  name 'NetLocalGroupSetInfo';
function NetLocalGroupDel; external NetApiDll name 'NetLocalGroupDel';
function NetLocalGroupDelMember; external NetApiDll
  name 'NetLocalGroupDelMember';
function NetLocalGroupGetMembers; external NetApiDll
  name 'NetLocalGroupGetMembers';
function NetLocalGroupSetMembers; external NetApiDll
  name 'NetLocalGroupSetMembers';
function NetLocalGroupAddMembers; external NetApiDll
  name 'NetLocalGroupAddMembers';
function NetLocalGroupDelMembers; external NetApiDll
  name 'NetLocalGroupDelMembers';
function NetQueryDisplayInformation; external NetApiDll
  name 'NetQueryDisplayInformation';
function NetGetDisplayInformationIndex; external NetApiDll
  name 'NetGetDisplayInformationIndex';
function RxNetAccessAdd; external NetApiDll name 'RxNetAccessAdd';
function RxNetAccessEnum; external NetApiDll name 'RxNetAccessEnum';
function RxNetAccessGetInfo; external NetApiDll name 'RxNetAccessGetInfo';
function RxNetAccessSetInfo; external NetApiDll name 'RxNetAccessSetInfo';
function RxNetAccessDel; external NetApiDll name 'RxNetAccessDel';
function RxNetAccessGetUserPerms; external NetApiDll
  name 'RxNetAccessGetUserPerms';
function NetGetDCName; external NetApiDll name 'NetGetDCName';
function NetGetAnyDCName; external NetApiDll name 'NetGetAnyDCName';
function I_NetLogonControl; external NetApiDll name 'I_NetLogonControl';
function I_NetLogonControl2; external NetApiDll name 'I_NetLogonControl2';
function NetEnumerateTrustedDomains; external NetApiDll
  name 'NetEnumerateTrustedDomains';

end.

